import java.util.List;
/**
 * Rozhrani IUtvar by měly implementovat třídy, které představují v rámci
 * organizační struktury útvar - organizační jednotku, která může obsahovat jiné
 * organizační jednotky či osoby. Zde definované metody jsou potřeba k tomu,
 * aby se zobrazila dobře stromová struktura pomocí JTree (třída GUI).
 *
 * @author     Luboš Pavlíček
 * @version    1.0, říjen 2006
 */
public interface IUtvar {

    /**
     * Metoda vrací seznam podřízených útvarů. 
     * V seznamu nesmí být duplicity (dle equals).
     * 
     * @return seznam podřízených útvarů.
     */
    public List<IUtvar> podrizeneUtvary();
    
    /**
     * Metoda vrací seznam konkrétních osob v rámci útvaru.
     * V seznamu nesmí být duplicity (dle equals).
     * 
     * @return seznam osob v útvaru.
     */
    public List<Osoba> osoby();

    /**
     * Metoda vrací řetězec, který se zobrazí ve stromu. Tato metoda je již definována
     * ve třídě Object, zde je uvedena pouze pro informaci v první větě.
     * 
     * @return vrací textovou reprezentaci skupiny, která se použije pro zobrazení ve stromu.
     */
    public String toString();
}
