import java.util.List;
/**
 * Třída představuje jeden útvar.
 *
 * @author     Luboš Pavlíček
 * @version    2.0, říjen 2006
 */
public class Utvar implements IUtvar {

    private String nazev;
    private String zkratka;
    
    /**
     * Konstruktor pro objekty tridy Utvar
     */
    public Utvar(String zkratka, String nazev) {
        this.zkratka = zkratka;
        this.nazev = nazev;
    }
    
    /**
     * Metoda vrací název útvaru
     * 
     * @return název útvaru
     */
    public String getNazev() { 
        return nazev;
    }
    
    /**
     * Metoda vrací zkratku útvaru
     * 
     * @return zkratka útvaru
     */
    public String getZkratka() {
        return zkratka;
    }
    
    /**
     * Metoda vloží osobu, která je členem útvaru
     * 
     * @param osoba osoba, která je členem útvaru
     */
    public void pridej (Osoba osoba) {
    }
    
    /**
     * Metoda vloží další podřízený útvar do aktuálního útvaru
     *
     * @param utvar podřízený útvar
     */
    public void pridej (Utvar utvar) {
    }
    
    /**
     * Metoda vrací seznam podřízených útvarů. 
     * V seznamu nesmí být duplicity (dle equals).
     * 
     * @return seznam podřízených útvarů.
     */
    public List<IUtvar> podrizeneUtvary() {
        return null;   // TODO
    }
    
    /**
     * Metoda vrací seznam konkrétních osob v rámci útvaru.
     * V seznamu nesmí být duplicity (dle equals).
     * 
     * @return seznam osob v útvaru.
     */
    public List<Osoba> osoby() {
        return null;     // TODO
    }

    /**
     * Metoda vrací řetězec, který se zobrazí ve stromu. Tato metoda je již definována
     * ve třídě Object, zde je uvedena pouze pro informaci v první větě.
     * 
     * @return vrací textovou reprezentaci útvaru, která se použije pro zobrazení ve stromu.
     */
    public String toString() {
        return zkratka+" "+nazev;
    }
    
    /**
     * Metoda equals pro porovnání s další instancí třídy Utvar (obecně s jakýmkoliv
     * objektem). Podrobný popis této metody je u třídy Object.
     * Dvě instance třídy Utvar jsou stejné, pokud mají
     * stejnou zkratku (tj. nezáleží na názvu útvaru). 
     *
     * @param o   druhý útvar/Object, se kterým se má aktuální instance porovnat
     * @return    true, pokud jsou instance stejné - pokud obsahují stejnou zkratku (název se 
     *                neporovnává).
     */
    public boolean equals(Object o) {
        if (o instanceof Utvar) {
            Utvar druha = (Utvar)o;
            return zkratka.equals(druha.getZkratka());
        }
        else {
            return false;
        }
    }
    
    /**
     * Metoda vrací číselnou hodnotu vyjadřující konkrétní instanci. Používá se pro optimalizaci
     * v dynamických datových strukturách. Bližší popis viz třída Object.
     * 
     * @return číselný kód vyjadřující instanci
     */
    public int hashCode() {
        return zkratka.hashCode();
    }
    
    
}
